#include "sfr_r833c.h"
#include "Timer.h"

// static֐錾
STATIC void tra_info_clear(void);

//staticϐ錾
static TRA_INFO g_tra_info;

/**
 * ^C}[RA
 */
void tra_init(void)
{
	tstart_tracr = 0;			// ^C}RAJEgJnrbg:0FJEg~

	traic = 0x00;				// ݗDxF0F݋֎~
	tstop_tracr = 1;			// ^C}RAJEg~rbgF1FZbg
	tramr = 0x00;				// ^C}RA샂[hIrbg
								//     0b-----000F^C}[h
								//     0b-000----Ff1F1
	trapre = TRA_PRE - 1;		// ^C}RAvXP[WX^
	tra = TRA - 1;				// ^C}RAWX^
								//     1 / [Clock Speed] * tramr * trapre * tra
								//     1 / 20M * 1 * 20 * 100
								//     = 0.0001sec = 100us
	traioc = 0x00;				// TRAIO[qIrbgFTRAIO[q͎gpȂ
	traic = 0x07;				// ݗDxF
								//     7F(~0,ŗDxၩ1234567)
	//tra_info_clear();
}

/**
 * ^C}[RAJn
 */
 void tra_start(void)
{
	interrupt_disable();		// ݋֎~
	traic = 0x07;
	tckcut_tramr = 0;			// ^C}RAJEg\[XՒfrbg:0 FJEg\[X
	tstart_tracr = 1;			// ^C}RAJEgJnrbg:1FJEgJn
	interrupt_enable();			// ݋
}

/**
 * ^C}[RA~
 */
void tra_stop(void)
{
	interrupt_disable();		// ݋֎~
	tstart_tracr = 0;			//^C}RAJEgJnrbg:0 : JEg~
	traic = 0x00;				//荞݋֎~
	tckcut_tramr = 1;
	//tstop_tracr = 1;
	interrupt_enable();			// ݋
}

/**
 * ^C}[RAݏ
 */
void tra_interrupt(void)
{
	if (!g_tra_info.is_busy && g_tra_info.count_diff)
	{
		g_tra_info.count += g_tra_info.count_diff;
		g_tra_info.count_diff = 0;
	}
	else
	{
		//DO_NOTHING();
	}

	if (g_tra_info.count < COUNT_OVERFLOW)
	{
		g_tra_info.count++;
	}
	else
	{
		// 
		g_tra_info.is_count_overflow = SET;
	}
}

/**
 * Wo߃`FbN
 * ^C}[RA݂ɓA10mso߂閈ɖ߂l̃tOTRUEɂȂ
 * @return sʂԂ
 * @retval TRUE		:10mso߂
 * @retval FALSE	:10mso߂ĂȂ
 */
BYTE tra_is_base_cycle_elapse(void)
{
	static BYTE ret = FALSE;

	ret = FALSE;

	if (g_tra_info.is_count_overflow)
	{
		tra_clear_base_cycle_overflow();//Ƃ肠
		//KvɉăG[ǉ
	}
	else if (g_tra_info.count >= COUNT_BASE_CYCLE)
	{
		ret = TRUE;
		g_tra_info.is_busy = TRUE;//݋֎~ł͂ȂAtOtra_int̂ݗ}
		g_tra_info.count_diff = g_tra_info.count - COUNT_BASE_CYCLE;//[i[
		g_tra_info.count = 0;//JE^NA
		g_tra_info.is_busy = FALSE;//݋֎~ł͂ȂAtOtra_int̂ݗ}
	}
	else
	{
		//Ȃ
	}

	return ret;
}

/**
 * W10msȓɏIȂԂNA
 */
void tra_clear_base_cycle_overflow(void)
{
	g_tra_info.is_count_overflow = CLEAR;
	g_tra_info.count_diff = 0;
	g_tra_info.count = 0;
}

/**
 * W10msȓɏIȂI[o[t[ԂԂ
 * @return sʂԂ
 * @retval TRUE		:I[o[t[
 * @retval FALSE	:I[o[t[Ȃ
 */
BYTE tra_is_base_cycle_overflow(void)
{
	return g_tra_info.is_count_overflow;
}

/**
 * W֘Aϐ
 */
STATIC void tra_info_clear(void)
{
	g_tra_info.count = 0;
	g_tra_info.count_diff = 0;
	g_tra_info.is_busy = FALSE;
	g_tra_info.is_count_overflow = FALSE;
}
