#include "typedefine.h"
/**********************************************************************************/
/* DEFINE                                                                         */
/**********************************************************************************/
//#define DEVICE_ADDRESS	0b01010101						/* b7:Do not set, b6-b0:Slave Address(7bit) */
#define DEVICE_ADDRESS	0x39						/* b7:Do not set, b6-b0:Slave Address(7bit) */
#define READ			1								/* R/W (IIC Master Receive) */
#define WRITE			0								/* R/W (IIC Master Transmit) */
#define LENGTH			8								/* Length of communication (0x01-0xFF) */
#define BUFSIZE			255								/* Size of buffer */

/**********************************************************************************/
/* Declaration of function prototype                                              */
/**********************************************************************************/
void iic_init(void);
BYTE g_iic_start(void);
void master_rcv_mode(void);
